#include "QUANTAnet_blockingTcp_c.hxx"

#include <stdio.h>

#ifndef WIN32
#include <netinet/tcp.h>
#else
#include <winsock.h>
#endif

QUANTAnet_tcpClient_c *QUANTAnet_blockingTcpServer_c::checkForNewConnections()
{
	struct sockaddr_in clientInfo;
	int clilen;

	clilen = sizeof(clientInfo);
	int newsockfd = accept(sockfd,
			       (struct sockaddr *) &clientInfo,
#ifdef _WIN32
			       (int *) &clilen);
#else
			       (socklen_t *) &clilen);
#endif
	if (newsockfd > 0) {
		struct linger lingerData;
		lingerData.l_onoff = 1;
		lingerData.l_linger = 1000;

		int optlen = sizeof(lingerData);
	
		if (setsockopt(newsockfd,SOL_SOCKET,SO_LINGER, (char *) &lingerData, optlen) < 0)
			printf("QUANTAnet_tcpServer_c::checkForNewConnections: setsockopt: SO_LINGER failed.\n");

		QUANTAnet_blockingTcpClient_c *clientObj;

		clientObj = new QUANTAnet_blockingTcpClient_c;
		clientObj->setTimeOutPeriod(timeOutPeriod);
		clientObj->setClientInfo(clientInfo);
		clientObj->setClientSockFd(newsockfd);

		return (QUANTAnet_tcpClient_c *) clientObj;
	} 
	else return NULL;
}

